<?php
/******************************************************************************
* paypal.php                                                                  *
*******************************************************************************
* SMF: Simple Machines Forum                                                  *
* Open-Source Project Inspired by Zef Hemel (zef@zefhemel.com)                *
* =========================================================================== *
* Software Version:           SMF 1.1 Beta 4                                  *
* Software by:                Simple Machines (http://www.simplemachines.org) *
* Copyright 2001-2006 by:     Lewis Media (http://www.lewismedia.com)         *
* Support, News, Updates at:  http://www.simplemachines.org                   *
*******************************************************************************
* This program is free software; you may redistribute it and/or modify it     *
* under the terms of the provided license as published by Lewis Media.        *
*                                                                             *
* This program is distributed in the hope that it is and will be useful,      *
* but WITHOUT ANY WARRANTIES; without even any implied warranty of            *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.                        *
*                                                                             *
* See the "license.txt" file for details of the Simple Machines license.      *
* The latest version can always be found at http://www.simplemachines.org.    *
******************************************************************************/

class paypal
{
	var $return_data;

	// Validate this is valid for this transaction type.
	function precheck()
	{
		global $modSettings, $txt, $webmaster_email;
	
		// Build the request string - starting with the minimum requirement.
		$requestString = 'cmd=_notify-validate';
	
		// Now my dear, add all the posted bits.
		foreach ($_POST as $k => $v)
		{
			// Append the string.
			$requestString .= '&' . $k . '=' . urlencode($v);
		}
	
		// Can we use curl?
		if (function_exists('curl_init') && $curl = curl_init('http://www.', !empty($modSettings['paidsubs_test']) ? 'sandbox.' : '', 'paypal.com/cgi-bin/webscr'))
		{
			// Set the post data.	
			curl_setopt($curl, CURLOPT_POST, true);
			curl_setopt($curl, CURLOPT_POSTFIELDSIZE, 0);
			curl_setopt($curl, CURLOPT_POSTFIELDS, $requestString);
		
			// Fetch the data returned as a string.
			curl_setopt($curl, CURLOPT_RETURNTRANSFER, true); 
		
			// Fetch the data.
			$this->return_data = curl_exec($curl);
		
			// Close the session.
			curl_close($curl);
		}
		// Otherwise good old HTTP.
		else
		{
			// Setup the headers.
			$header = "POST /cgi-bin/webscr HTTP/1.0\r\n";
			$header .= "Content-Type: application/x-www-form-urlencoded\r\n";
			$header .= "Content-Length: " . strlen ($requestString) . "\r\n\r\n";
		
			// Open the connection.
			$fp = fsockopen('www.' . (!empty($modSettings['paidsubs_test']) ? 'sandbox.' : '') . 'paypal.com', 80, $errno, $errstr, 30);
		
			// Did it work?
			if (!$fp)
				generateError($txt['paypal_could_not_connect']);
		
			// Put the data to the port.
			fputs($fp, $header . $requestString);
		
			// Get the data back...
			while (!feof($fp))
			{
				$this->return_data = fgets($fp, 1024);
				if (strcmp($this->return_data, 'VERIFIED') == 0)
					break;
			}
		
			// Clean up.
			fclose($fp);
		}
	
		// If this isn't verified then give up...
		if (strcmp($this->return_data, 'VERIFIED') != 0)
		{
			// Send an email.
			sendmail($webmaster_email, $txt['paypal_unverified_subject'], $txt['paypal_unverified_body']);
			exit;
		}
	
		// Check that this is intended for us.
		if ($_POST['business'] != $modSettings['paypal_email'])
			exit;

		// Is this a subscription - and if so it's it a secondary payment that we need to process?
		if ($this->isSubscription() && (empty($_POST['item_number']) || strpos($_POST['item_number'], '+') === false))
		{
			// Calculate the subscription it relates to!
			$this->_findSubscription();
		}

		// Verify the currency!
		if (strtolower($_POST['mc_currency']) != $modSettings['currency_code'])
			exit;

		// Can't exist if it doesn't contain anything.
		if (empty($_POST['item_number']))
			exit;

		// Return the ID_SUB and ID_MEMBER
		return explode('+', $_POST['item_number']);
	}

	// Is this a refund?
	function isRefund()
	{
		if ($_POST['payment_status'] == 'Refunded' || $_POST['payment_status'] == 'Reversed' || $_POST['txn_type'] == 'Refunded' || ($_POST['txn_type'] == 'reversal' && $_POST['payment_status'] == 'Completed'))
			return true;
		else
			return false;
	}

	// Is this a subscription?
	function isSubscription()
	{
		if (substr($_POST['txn_type'], 0, 14) == 'subscr_payment')
			return true;
		else
			return false;
	}

	// Is this a normal payment?
	function isPayment()
	{
		if ($_POST['payment_status'] == 'Completed' && $_POST['txn_type'] == 'web_accept')
			return true;
		else
			return false;
	}

	// How much was paid?
	function getCost()
	{
		return $_POST['tax'] + $_POST['mc_gross'];
	}

	// exit.
	function close()
	{
		global $db_prefix, $ID_SUB;

		// If it's a subscription record the reference.
		if ($_POST['txn_type'] == 'subscr_payment' && !empty($_POST['subscr_id']))
		{
			$_POST['subscr_id'] = addslashes($_POST['subscr_id']);
			db_query("
				UPDATE {$db_prefix}log_subscribed
				SET vendor_ref = '$_POST[subscr_id]'
				WHERE id_sublog = $ID_SUB", __FILE__, __LINE__);
		}

		exit();
	}

	// A private function to find out the subscription details.
	function _findSubscription()
	{
		global $db_prefix;

		// Assume we have this?
		if (empty($_POST['subscr_id']))
			return false;
		$_POST['subscr_id'] = addslashes($_POST['subscr_id']);

		// Do we have this in the database?
		$request = db_query("
			SELECT ID_MEMBER, ID_SUBSCRIBE
			FROM {$db_prefix}log_subscribed
			WHERE vendor_ref = '$_POST[subscr_id]'
			LIMIT 1", __FILE__, __LINE__);
		// No joy?
		if (mysql_num_rows($request) == 0)
		{
			// Can we identify them by email?
			if (!empty($_POST['payer_email']))
			{
				mysql_free_result($request);
				$_POST['payer_email'] = addslashes($_POST['payer_email']);
				$request = db_query("
					SELECT ls.ID_MEMBER, ls.ID_SUBSCRIBE
					FROM {$db_prefix}log_subscribed AS ls
						INNER JOIN {$db_prefix}members AS mem ON (mem.id_member = ls.id_member)
					WHERE mem.emailAddress = '$_POST[payer_email]'
					LIMIT 1", __FILE__, __LINE__);
				if (mysql_num_rows($request) == 0)
					return false;
			}
			else
				return false;
		}
		list ($ID_MEMBER, $ID_SUB) = mysql_fetch_row($request);
		$_POST['item_number'] = $ID_MEMBER . '+' . $ID_SUB;
		mysql_free_result($request);
	}
}

?>